import java.util.*;

public class Tokens   // my version of StringTokenizer class
{
 public  String[] toks;
 public  String original;
 public  int i; // index
 public  int n = 0;     // length
    // default delim is " \t\n\r\f", false
 public  Tokens(String s, String delim, boolean b)
    {
       original = s;
       StringTokenizer st;
       st = new StringTokenizer(s,delim,b);
       n = st.countTokens();
       toks = new String[n];
       for(int j=0;j<n;j++) toks[j] = st.nextToken();
       i = 0;
    }

    // this version returns embedded strings as one token
    // it does not return delimiters
 public Tokens(String s, String delim)
    {	original = s;
	StringTokenizer st = new StringTokenizer(s,delim,true);
	toks = new String[st.countTokens()];  // upper bound;
	String token = "";
	n = 0;
	i = 0;
	int j = 0;

       while (j<s.length())
       {
	while(j<s.length() && instring(s.charAt(j),delim)) j++; // skip delims
	if (j<s.length() && s.charAt(j) != (char)34)  // 34 = "
	    {
		while (j<s.length() && (!instring(s.charAt(j),delim))) 
		    {
			token = token + s.charAt(j++);
		    }
		toks[n++] = token;  token = "";
	    } // not string
	else if (j<s.length())
	    { 
		j++;  //skip opening quote
		while (j<s.length() && (s.charAt(j) != (char)34))
		    {
			token = token + s.charAt(j++);
		    }
		j++; // skip the end quote
		toks[n++] = token;  token = "";
	    } // string
       } // outer while
    }

 public boolean hasMoreTokens() { return i<n; }
 public String nextToken() { return toks[i++]; }
 public int countTokens() { return n-i; }
 public String lookahead() { return toks[i]; }
 public void skip() { if (i<n) i++; }
 public void backup() { if (i>0) i--; }
 public void reset() { i = 0; }
 public String toString() 
    {   int j = i;
        String s = "";
        while (j<n) s = s + toks[j++] + "\n";
        return s;
    }

    public static String discern(String s, char c) 
    {   String t = "";
	int i = 0;
	while (i<s.length())
	    {
		if (s.charAt(i) == c)
			t = t + " " + s.charAt(i) + " ";
		else t = t+s.charAt(i);
		i++;
	    } // while
	return t;
    }

    public static boolean instring(char c, String s)
    {   boolean ax = false;
	for (int i=0;i<s.length() && (!ax);i++)
	    if (s.charAt(i) == c) ax = true;
	return ax;
    }

}  // my Tokens class

