import java.io.*;
import java.net.*;

public class colclient   // specific client proxies will extend this class
{
    private static final int colport = 20027; // fixed port

    private Socket cfd;  // TCP socket to server
    private DataInputStream din;
    private PrintWriter pout;
    private byte[] buffer; // used by receive
   
    // constructor opens connection to server, sets up io streams:
   public colclient(String serveraddr)
    {
	try 
	{
	    buffer = new byte[2048];
	    cfd = new Socket(InetAddress.getByName(serveraddr),colport);
	    din = new DataInputStream(cfd.getInputStream());
	    pout = new PrintWriter(
			  new OutputStreamWriter(cfd.getOutputStream()),true);
	} catch (IOException e) {e.printStackTrace();}
    }
    
   public void close()
    {
	try {cfd.close();} catch(IOException e) {e.printStackTrace();}
    }

    // send COL abstract syntax to server
   protected void send(cterm request)
    {
      try
	  {
	      String s = colserver.writeCterm(request);
	      pout.println(s);
	  }
      catch (Exception e) {e.printStackTrace();}
    } // send

    // receive COL term from server
  protected cterm receive()
    {   String s = null;
	try
	    {
		int n = din.read(buffer,0,2047); // read from socket n bytes
		if (n>0) { buffer[n] = 0;  // zero-terminate string
		           s = new String(buffer,0,n);
		         }
	    }
	catch (IOException e) {e.printStackTrace();}
	return colserver.parseterm(s);
    }
}  // colclient superclass


