import java.io.*;
import java.net.*;

public class democlient implements demo
{
    private static final int colport = 20027; // fixed port

    private Socket cfd;  // TCP socket to server
    private DataInputStream din;
    private PrintWriter pout;
    private byte[] buffer; // used by receive
   
    // constructor opens connection to server, sets up io streams:
   public democlient(String serveraddr)
    {
	try 
	{
	    buffer = new byte[2048];
	    cfd = new Socket(InetAddress.getByName(serveraddr),colport);
	    din = new DataInputStream(cfd.getInputStream());
	    pout = new PrintWriter(
			  new OutputStreamWriter(cfd.getOutputStream()),true);
	} catch (IOException e) {e.printStackTrace();}
    }
    
   public void close()
    {
	try {cfd.close();} catch(IOException e) {e.printStackTrace();}
    }

   private void send(cterm request)
    {
      try
	  {
	      String s = colserver.writeCterm(request);
	      pout.println(s);
	  }
      catch (Exception e) {e.printStackTrace();}
    } // send

  private cterm receive()
    {   String s = null;
	try
	    {
		int n = din.read(buffer,0,2047); // read from socket n bytes
		if (n>0) { buffer[n] = 0;  // zero-terminate string
		           s = new String(buffer,0,n);
		         }
	    }
	catch (IOException e) {e.printStackTrace();}
	return colserver.parseterm(s);
    }



    /* they implement this: */
   public int f(int a0)
    {
	send(new CAPP(new ID(0),new CIC(a0)));
	cterm answer = receive();
	return colserver.ctermToint(answer);
    }


   public String h()
    {
	send(new ID(1));
	cterm answer = receive();
	return colserver.ctermToString(answer);
    }

   public int randnum(int a0,int a1)
    {
	send(new CAPP(new CAPP(new ID(2),new CIC(a0)),new CIC(a1)));
	cterm answer = receive();
	return colserver.ctermToint(answer);
    }

   public static void main(String[] args)
    {
	demo proxy = new democlient(args[0]);
	System.out.println(proxy.h());
    }

} 

