// COL meta-compiler for java in java

import java.io.*;

public class mcj
{
    public static PrintWriter pw;
    public static colsig sig;
   
    public static void writeinterface(String intname) throws Exception
    {
	pw = new PrintWriter(new OutputStreamWriter(
		   new FileOutputStream(intname+".java")));
	pw.println("/* this file was automatically generated by mcj.java */");
	pw.println("\npublic interface " + intname);
	pw.println("{");  

        ctype returntype = null;
	colsig decl = sig;  // pointer to sucessive decs
        int arity = 0;
	String argv = "";
	  while (decl != null)
	      {
		arity = decl.type.arity();
		returntype = decl.type.targettype();
		if (arity>0) argv = decl.type.toString();
		   else argv = "()";
		// write the java declaration:
		pw.println("\t" + returntype + " " + decl.id + argv + ";");
		pw.flush();
		decl = decl.next;
	      } // for each declaration in sig list

	pw.println("}");
	pw.close();
    } // writeinterface

    public static void writeimpl(String intname) throws Exception
    {
        String implclass = intname+"impl";

	pw = new PrintWriter(new OutputStreamWriter(
		   new FileOutputStream(implclass+".java")));
	pw.println("/* finish this class to implement "+intname+" */\n");
	pw.println("public class "+implclass+" implements " + intname);
	pw.println("{\n\n}");

	pw.close();
    } //writeimpl
  
    public static void writeserver(String intname) throws Exception
    {
       String serverclass = intname+"server";
       pw = new PrintWriter(new OutputStreamWriter(
		   new FileOutputStream(serverclass+".java")));
       
       pw.println("/* this file was automatically generated by mcj.java */\n");
       pw.print("public class "+serverclass+" extends colserver\n{");
       // instance of server class:
       pw.println("  private "+intname+" server;\n");
       // constructor
       pw.println("  public "+serverclass+"()\n  {");
       
       // create instance of server
       pw.println("\tserver = new "+intname+"impl();");
       // create Match array
       int len = sig.length();
       pw.println("\tMatch = new serverfun["+ len +"];");
       
       // initialize Match entries:
       colsig dec = sig;
       for(int i=0;i<len;i++)
	   {
              pw.println("\tMatch["+i+"] = new serverfun()");
	      pw.println("\t  {\n\t\tpublic cterm fun(cterm t)\n\t\t{");

	      // interior of serverfun function

	      int ar = dec.type.arity();
	      for(int j=1;j<=ar;j++)
		  {
		      String tname = ((artype)dec.type).nthtype(j).toString();
		      pw.print("\t\t  "+tname+" x"+j+ " = ctermTo"+tname);
		      pw.println("(nthterm(t,"+j+"));");
		  } // for j
	      String tname = dec.type.targettype().toString();
	      pw.print("\t\t  return "+tname+"ToCterm(server."+dec.id+"(");
	      for(int j=1;j<=ar;j++)
		  {
		      pw.print("x"+j);
		      if (j<ar) pw.print(",");
		  }
	      pw.println("));");

	      pw.println("\t\t}");
	      pw.println("\t  };\n");
	      dec = dec.next;
	   } // for each dec

       pw.println("  }\n"); // close constructor


       // generate main
       pw.println("  public static void main(String[] args)");
       pw.println("  {\n\t"+serverclass+" serverobj = new "+serverclass+"();");
       pw.println("\tserverobj.serve();\n  }");
       
       pw.println("}");   // close class
       pw.close();
    } // writeserver


    public static void main(String[] args)  // args[0] = .col file
    { try
      {
          sig = sigparser.parsefile(args[0]+".col");
	  System.out.println("parsed file");
	  String intclass = args[0];
	  writeinterface(intclass);
	  System.out.println("written interface");
	  writeimpl(intclass);
	  System.out.println("written impl shell");
	  writeserver(intclass);
	  System.out.println("written colserver subclass");
      } catch(Exception e) {e.printStackTrace();}
    } // main

} // mcj



/* outline

parse .col file.

keep counter for id

generate interface
generate stub of impl file
generate subclass of colserver
  by writing constructor and main

*/
